Tidy up a bit more, fix tab and remove trailing whitespaces
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
46 # should be installed.
47 INSTALL_LIBLTO="$9"
48
49 # A yes/no parameter that controls whether to cross-build for an ARM host.
50 ARM_HOSTED_BUILD="${10}"
51
52 # A yes/no parameter that controls whether to cross-build for the iOS simulator
53 IOS_SIM_BUILD="${11}"
54
55 # The version number of the submission, e.g. 1007.
56 LLVM_SUBMIT_VERSION="${12}"
57
58 # The subversion number of the submission, e.g. 03.
59 LLVM_SUBMIT_SUBVERSION="${13}"
60
61 # The current working directory is where the build will happen. It may already
62 # contain a partial result of an interrupted build, in which case this script
63 # will continue where it left off.
64 DIR=`pwd`
65
66 DARWIN_VERS=`uname -r | sed 's/\..*//'`
67 echo DARWIN_VERS = $DARWIN_VERS
68
69 ################################################################################
70 # Run the build.
71
72 # Create the source tree we'll actually use to build, deleting
73 # tcl since it doesn't actually build properly in a cross environment
74 # and we don't really need it.
75 SRC_DIR=$DIR/src
76 rm -rf $SRC_DIR || exit 1
77 mkdir $SRC_DIR || exit 1
78 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
79 # We can't use the top-level Makefile as-is.  Remove the soft link:
80 rm $SRC_DIR/Makefile || exit 1
81 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
82 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
83
84 # Build the LLVM tree universal.
85 mkdir -p $DIR/obj-llvm || exit 1
86 cd $DIR/obj-llvm || exit 1
87
88 if [ "$ARM_HOSTED_BUILD" = yes ]; then
89   # The cross-tools' build process expects to find an existing cross toolchain
90   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
91   rm -rf $DIR/bin || exit 1
92   mkdir $DIR/bin || exit 1
93   for prog in ar nm ranlib strip lipo ld as ; do
94     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
95     T=`xcrun -sdk $SDKROOT -find ${prog}`
96     echo '#!/bin/sh' > $P || exit 1
97     echo 'exec '$T' "$@"' >> $P || exit 1
98     chmod a+x $P || exit 1
99   done
100   # Set up the links for clang.
101   for prog in clang clang++ ; do
102     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
103     T=`xcrun -sdk $SDKROOT -find ${prog}`
104     echo '#!/bin/sh' > $P || exit 1
105     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
106     chmod a+x $P || exit 1
107   done
108
109   PATH=$DIR/bin:$PATH
110 fi
111
112 if [ "$ARM_HOSTED_BUILD" = yes ]; then
113   configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
114                   --target=arm-apple-darwin10 --build=i686-apple-darwin10"
115 elif [ "$IOS_SIM_BUILD" = yes ]; then
116   # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
117   configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
118                   --build=i686-apple-darwin10"
119 else
120   configure_opts="--enable-targets=arm,x86,cbe"
121 fi
122
123 if [ \! -f Makefile.config ]; then
124   $SRC_DIR/configure --prefix=$DEST_DIR$DEST_ROOT $configure_opts \
125     --enable-assertions=$LLVM_ASSERTIONS \
126     --enable-optimized=$LLVM_OPTIMIZED \
127     --disable-bindings \
128     || exit 1
129 fi
130
131 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
132
133 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
134     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
135     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
136     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
137 fi
138
139 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
140     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
141 else
142     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
143 fi
144
145 GCC_VER=`cc --version 2>/dev/null | sed 1q`
146
147 if echo "$GCC_VER" | grep GCC > /dev/null; then
148     GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
149     MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
150     MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
151 fi
152
153 JOBS_FLAG=""
154
155 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
156 # already has parallelism and we don't want to make the builders hit swap by
157 # firing off too many gccs at the same time.
158 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
159     # Figure out how many make processes to run.
160     SYSCTL=`sysctl -n hw.activecpu`
161
162     # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
163     # Builders can default to 2, since even if they are single processor,
164     # nothing else is running on the machine.
165     if [ -z "$SYSCTL" ]; then
166         SYSCTL=2
167     fi
168
169     JOBS_FLAG="-j $SYSCTL"
170 fi
171
172 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
173     UNIVERSAL_SDK_PATH=$SDKROOT \
174     NO_RUNTIME_LIBS=1 \
175     DISABLE_EDIS=1 \
176     DEBUG_SYMBOLS=1 \
177     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
178     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
179     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
180     VERBOSE=1
181
182 if [ $? != 0 ] ; then
183     echo "error: LLVM 'make' failed!"
184     exit 1
185 fi 
186
187 ################################################################################
188 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
189 # $DEST_DIR, with occasional 'lipo' commands.
190
191 cd $DEST_DIR || exit 1
192
193 # Clean out DEST_DIR in case -noclean was passed to buildit.
194 rm -rf * || exit 1
195
196 cd $DIR/obj-llvm || exit 1
197
198 # Install the tree into the destination directory.
199 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
200     NO_RUNTIME_LIBS=1 \
201     DISABLE_EDIS=1 \
202     DEBUG_SYMBOLS=1 \
203     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
204     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
205     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
206
207 if ! test $? == 0 ; then
208     echo "error: LLVM 'make install' failed!"
209     exit 1
210 fi 
211
212 # Install Version.h
213 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
214 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
215     LLVM_MINOR_VERSION=0
216 fi
217 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
218 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
219 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
220
221 if [ "x$LLVM_DEBUG" != "x1" ]; then
222     # Strip local symbols from llvm libraries.
223     #
224     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
225     # PPC objects!
226     strip -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
227     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
228         strip -Sxl $f
229     done
230 fi
231
232 # Copy over the tblgen utility.
233 cp `find $DIR -name tblgen` $DEST_DIR$DEST_ROOT/bin
234
235 # Remove .dir files 
236 cd $DEST_DIR$DEST_ROOT
237 rm -f bin/.dir etc/llvm/.dir lib/.dir
238
239 # Remove PPC64 fat slices.
240 cd $DEST_DIR$DEST_ROOT/bin
241 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
242     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
243         -exec lipo -extract ppc -extract i386 {} -output {} \;
244 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
245     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
246         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
247 else
248     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
249         -exec lipo -extract i386 -extract x86_64 {} -output {} \;
250 fi
251
252 # The Hello dylib is an example of how to build a pass.
253 # The BugpointPasses module is only used to test bugpoint.
254 # These unversioned dylibs cause verification failures, so do not install them.
255 # (The wildcards are used to match a "lib" prefix if it is present.)
256 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
257 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
258
259 # Compress manpages
260 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
261 gzip -f $MDIR/*
262
263 ################################################################################
264 # Create SYM_DIR with information required for debugging.
265
266 # Figure out how many make processes to run.
267 SYSCTL=`sysctl -n hw.activecpu`
268
269 # hw.activecpu only available in 10.2.6 and later
270 if [ -z "$SYSCTL" ]; then
271   SYSCTL=`sysctl -n hw.ncpu`
272 fi
273
274 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
275 # can default to 2, since even if they are single processor, nothing else is
276 # running on the machine.
277 if [ -z "$SYSCTL" ]; then
278   SYSCTL=2
279 fi
280
281 cd $SYM_DIR || exit 1
282
283 # Clean out SYM_DIR in case -noclean was passed to buildit.
284 rm -rf * || exit 1
285
286 # Generate .dSYM files
287 find $DEST_DIR -perm -0111 -type f \
288     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
289     -print | xargs -n 1 -P ${SYSCTL} dsymutil
290
291 # Save .dSYM files and .a archives
292 cd $DEST_DIR || exit 1
293 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
294     | cpio -pdml $SYM_DIR || exit 1
295
296 # Save source files.
297 mkdir $SYM_DIR/src || exit 1
298 cd $DIR || exit 1
299 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
300     | cpio -pdml $SYM_DIR/src || exit 1
301
302 ################################################################################
303 # Install and strip libLTO.dylib
304
305 cd $DEST_DIR$DEST_ROOT
306 if [ "$INSTALL_LIBLTO" = "yes" ]; then
307   DT_HOME="$DEST_DIR/Developer/usr"
308   mkdir -p $DT_HOME/lib
309   mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
310
311   # Save a copy of the unstripped dylib
312   mkdir -p $SYM_DIR/Developer/usr/lib
313   cp $DT_HOME/lib/libLTO.dylib $SYM_DIR/Developer/usr/lib/libLTO.dylib
314
315   # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
316   # PPC objects!
317   strip -arch all -Sl $DT_HOME/lib/libLTO.dylib
318
319   if [ "x$DISABLE_USR_LINKS" == "x" ]; then
320     # Add a symlink in /usr/lib for B&I.
321     mkdir -p $DEST_DIR/usr/lib/
322     (cd $DEST_DIR/usr/lib && \
323       ln -s ../../Developer/usr/lib/libLTO.dylib ./libLTO.dylib)
324   fi
325 else
326   rm -f lib/libLTO.dylib
327 fi
328 rm -f lib/libLTO.a lib/libLTO.la
329
330 # Omit lto.h from the result.  Clang will supply.
331 find $DEST_DIR$DEST_ROOT -name lto.h -delete
332
333 ################################################################################
334 # Remove debugging information from DEST_DIR.
335
336 cd $DIR || exit 1
337
338 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
339 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
340
341 # Strip debugging information from files
342 #
343 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
344 # PPC objects!
345 find $DEST_DIR -perm -0111 -type f \
346     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
347     -print | xargs -n 1 -P ${SYSCTL} strip -arch all -Sl
348
349 chgrp -h -R wheel $DEST_DIR
350 chgrp -R wheel $DEST_DIR
351
352 ################################################################################
353 # Remove the docs directory
354
355 rm -rf $DEST_DIR$DEST_ROOT/docs
356
357 ################################################################################
358 # w00t! Done!
359
360 exit 0